Graphics3D 800,600,16,2
SetBuffer BackBuffer()
Dither True 

SeedRnd MilliSecs() 
;===>
Include "commontype.bb"
;Include "Shadow_Include.bb"
Include "Shadow_IncludeNew.bb"

;===>
camera = CreateCamera()
PositionEntity camera,0,-2,-7;4

PointEntity Camera, CreatePivot()
CameraRange Camera, .1, 1000
CamPiv = CreatePivot()


SHW_Init()


;Scene
CreateScene()

;Light
Light = CreateLight()
aa=CreateSphere()
ScaleEntity aa,0.1,0.1,0.1
EntityParent aa,Light

While Not KeyHit(1)
	ms = ms + 1
	PositionEntity Light, Cos(ms * 1.7) * 7, 5, Sin(ms * 1.7) * 7
	PointEntity Light, CamPiv
	PositionEntity Camera, Cos(ms) *5, 4.5, Sin(ms) *5
	PointEntity Camera, CamPiv
	; Key "v"
	If KeyHit(47) Then
		If  vol Then
			Vol=False 
		Else
			Vol=True
		EndIf
	EndIf

	UpdateWorld()
	S$=ShadowVolume(Light,4000)

	If vol Then
		ShowEntity MeshFront
		EntityColor MeshFront, 255, 0,0
		EntityFX MeshFront,16+1
	Else
		HideEntity MeshFront
	EndIf

	;===>
	RenderWorld()
	;===>
	If vol Then
		SHWLine3D()
	EndIf

	Flip
Wend

End

Function CreateScene()
Tex_Marble = LoadTexture("Media\Marble.jpg")
Tex_MarbleStones = LoadTexture("Media\MarbleStones.jpg")
Tex_SandStone = LoadTexture("Media\SandStone.jpg")

;Room
c = LoadMesh("Media\Room.3ds")
RotateEntity c, -90, 0, 0
EntityTexture c, Tex_MarbleStones
;SHW_InitObject(c) 
EntityParent  c,scena
;Grid
c = LoadMesh("Media\Grid.3ds")
RotateEntity c, -90, 0, 0
EntityTexture c, Tex_Marble
EntityParent  c,scena
SHW_InitObject(c) 

;c = LoadMesh("Media\Grid2.3ds")
For x = -4 To 4
	For z = -1 To 1 Step 2
;		c = CreateCylinder(11)
;		PositionEntity c, x, -2, 5 * z
;		ScaleEntity c, .25, 2, .25
;		EntityTexture c, Tex_Marble
;		EntityParent  c,scena
;		SHW_InitObject(c)
;
		c = CreateCylinder(11)
		PositionEntity c, 5 * z, -2, x
		ScaleEntity c, .25, 2, .25
		EntityTexture c, Tex_Marble
		EntityParent  c,scena
		;SHW_InitObject(c)
	Next
Next

;Statue
c = LoadMesh("Media\warrior.3ds")
ScaleEntity c, .15, .15, .15
PositionEntity c, 0, -1.5, 0
EntityParent  c,scena
SHW_InitObject(c) 

;Stone
c = CreateSphere()
ScaleEntity c, 2, .8, 2
PositionEntity c, 0, -3.5, 0
EntityTexture c, Tex_SandStone
EntityParent  c,scena
SHW_InitObject(c)

End Function